## openjdk-25 25~16ea

=== test/hotspot/jtreg/testlibrary/jittester/Makefile ===
#
# Copyright (c) 2015, 2024, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#

ifeq "x$(BOOTDIR)" "x"
	JDK_HOME := $(shell dirname $(shell which java))/..
else
	JDK_HOME := $(BOOTDIR)
endif

ifeq "x$(PROPERTY_FILE)" "x"
	PROPERTY_FILE := conf/default.properties
endif

ifeq "x$(TESTBASE_DIR)" "x"
	TESTBASE_DIR := ws/hotspot/test
endif

APPLICATION_ARGS =
ifneq "x$(TESTS_NUMBER)" "x"
	APPLICATION_ARGS += --number-of-tests $(TESTS_NUMBER)
endif

ifneq "x$(SEED)" "x"
	APPLICATION_ARGS += --seed $(SEED)
endif

ifneq "x$(EXTRA_SRC_DIR)" "x"
        EXTRA_SRC_FILES := $(shell find $(EXTRA_SRC_DIR) -name '*.java')
endif

JAVA = $(JDK_HOME)/bin/java
JAVAC = $(JDK_HOME)/bin/javac
JAR = $(JDK_HOME)/bin/jar

BUILD_DIR = build
CLASSES_DIR = $(BUILD_DIR)/classes
SRC_DIR = src
TEST_DIR = test
MANIFEST = manifest.mf
APPLICATION_ARGS += \
    --property-file $(PROPERTY_FILE) \
    --testbase-dir $(TESTBASE_DIR)
MAIN_CLASS = JitTestGenerator.Automatic

TESTGROUP_FILE = $(TESTBASE_DIR)/TEST.groups
TESTROOT_FILE =  $(TESTBASE_DIR)/TEST.ROOT

DIST_DIR = dist
DIST_JAR = $(DIST_DIR)/JITtester.jar

SRC_FILES = $(shell find $(SRC_DIR) -name '*.java')
TESTLIBRARY_SRC_DIR = ../../../../lib/jdk/test/lib
TESTLIBRARY_SRC_FILES = $(TESTLIBRARY_SRC_DIR)/Asserts.java \
                        $(TESTLIBRARY_SRC_DIR)/JDKToolFinder.java \
                        $(TESTLIBRARY_SRC_DIR)/JDKToolLauncher.java \
                        $(TESTLIBRARY_SRC_DIR)/NetworkConfiguration.java \
                        $(TESTLIBRARY_SRC_DIR)/Platform.java \
                        $(TESTLIBRARY_SRC_DIR)/Utils.java \
                        $(TESTLIBRARY_SRC_DIR)/process/OutputAnalyzer.java \
                        $(TESTLIBRARY_SRC_DIR)/process/OutputBuffer.java \
                        $(TESTLIBRARY_SRC_DIR)/process/ProcessTools.java \
                        $(TESTLIBRARY_SRC_DIR)/process/StreamPumper.java \
                        $(TESTLIBRARY_SRC_DIR)/util/FileUtils.java \
                        $(TESTLIBRARY_SRC_DIR)/util/Pair.java

.PHONY: cleantmp

all: $(DIST_JAR)

$(DIST_JAR): INIT COMPILE manifest
	$(JAR) cfm $(DIST_JAR) $(MANIFEST) -C $(CLASSES_DIR) .

manifest:
	@echo 'Manifest-Version: 1.0' > $(MANIFEST)
	@echo 'X-COMMENT: Main-Class will be added automatically by build' >> $(MANIFEST)
	@echo 'Main-Class: jdk.test.lib.jittester.Automatic' >> $(MANIFEST)

compile_testlib: INIT
	$(JAVAC) -XDignore.symbol.file --add-exports=java.base/jdk.internal.misc=ALL-UNNAMED --add-exports=java.base/org.objectweb.asm=ALL-UNNAMED -Xlint $(TESTLIBRARY_SRC_FILES) -d $(CLASSES_DIR)

COMPILE: INIT filelist compile_testlib
	$(JAVAC) -cp $(CLASSES_DIR) -XDignore.symbol.file --add-exports=java.base/jdk.internal.misc=ALL-UNNAMED --add-exports=java.base/org.objectweb.asm=ALL-UNNAMED -Xlint -sourcepath $(SRC_DIR) -d $(CLASSES_DIR) @filelist

filelist: $(SRC_FILES)
		@rm -f $@
		@echo $(SRC_FILES) > $@
		@echo $(EXTRA_SRC_FILES) >> $@

INIT: $(DIST_DIR)
	$(shell if [ ! -d $(CLASSES_DIR) ]; then mkdir -p $(CLASSES_DIR); fi)

install: clean_testbase testgroup testroot copytestlibrary $(DIST_JAR) cleantmp
	$(JAVA) --add-exports=java.base/org.objectweb.asm=ALL-UNNAMED --add-opens java.base/java.util=ALL-UNNAMED -ea -jar $(DIST_JAR) $(APPLICATION_ARGS)

clean_testbase:
	@rm -rf $(TESTBASE_DIR)

cleantmp:
	@rm filelist
	@rm -rf $(CLASSES_DIR)

copytestlibrary: $(TESTBASE_DIR)/jdk/test/lib/jittester/jtreg
	@cp -r src/jdk/test/lib/jittester/jtreg/*.java $(TESTBASE_DIR)/jdk/test/lib/jittester/jtreg
	@cp -r $(TESTLIBRARY_SRC_DIR) $(TESTBASE_DIR)/jdk/test/

testgroup: $(TESTBASE_DIR)
	@echo 'jittester_all = \' > $(TESTGROUP_FILE)
	@echo '	/' >> $(TESTGROUP_FILE)
	@echo '' >> $(TESTGROUP_FILE)
	@echo 'jit_tests = \' >> $(TESTGROUP_FILE)
	@echo ' java_tests \' >> $(TESTGROUP_FILE)
	@echo ' bytecode_tests' >> $(TESTGROUP_FILE)
	@echo '' >> $(TESTGROUP_FILE)

testroot: $(TESTBASE_DIR)
	@echo 'groups=TEST.groups' > $(TESTROOT_FILE)

$(TESTBASE_DIR) $(DIST_DIR) $(TESTBASE_DIR)/jdk/test/lib/jittester/jtreg:
	$(shell if [ ! -d $@ ]; then mkdir -p $@; fi)

## openjdk-25 25~4ea

=== debian/changelog ===
openjdk-25 (25~4ea-1) experimental; urgency=medium

  * OpenJDK 25 snapshot, Build 4.

  [ Vladimir Petko ]
  * d/rules: Set JVM thread size and Java thread size for power architectures and S390x
    to avoid a stack overflow error.

  [ Matthias Klose ]
  * d/rules: Also do the above fix for alpha and sparc64.
  * Try to work-around a ftbfs on alpha.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 05 Jan 2025 13:09:04 +0100

openjdk-25 (25~0ea-1) experimental; urgency=medium

  * OpenJDK 25 snapshot, Build 0.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 06 Dec 2024 11:27:05 +0100

openjdk-24 (24~26ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 26.

  [ Matthias Klose ]
  * d/patches/{atk-wrapper-security,update-permission-test}: Disable.
  * d/patches/warn-fontmanager: Update.

  [ Pushkar Kulkarni ]
  * For jammy, work around GCC ICE on armhf. See LP #1953128.
  * d/t/problems.csv: Update based on recent JTREG runs.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 29 Nov 2024 12:21:53 +0100

openjdk-24 (24~22ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 22.
  * Consolidate setting of dtrace architectures.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 01 Nov 2024 10:57:23 +0100

openjdk-24 (24~20ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 20.

  [ Vladimir Petko ]
  * d/rules: Do not include dtrace support for S390x (JDK-8305174).
  * d/t/problems.csv: Disable jdk/sun/security/util/Debug/DebugOptions.java
    due to JDK-8339713.
  * d/rules: Disable hotspot for i386 (JDK-8341871).

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2024 09:05:23 +0200

openjdk-24 (24~16ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 16.
  * Bump standards version.
  * Refresh patches.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Sep 2024 17:08:21 +0200

openjdk-24 (24~14ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 14.

  * Stop providing the versioned names javaNN-sdk-headless, javaNN-sdk,
    javaNN-runtime-headless, javaNN-runtime-headless. The versioned
    provides java-sdk-headless, java-sdk, java-runtime-headless and
    java-runtime-headless exist since OpenJDK 17.

  [ Vladimir Petko ]
  * d/p/reproducible-properties-timestamp.diff: Use PrivilegedAction
    to avoid SecurityManager exception.
  * Enable dtrace support.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2024 22:24:27 +0200

openjdk-24 (24~10ea-2) unstable; urgency=medium

  * Fix typo in jre-headless dependencies.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 11 Aug 2024 02:52:32 +0200

openjdk-24 (24~10ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 10.

  [ Vladimir Petko ]
  * d/changelog: Remove trailing empty line.
  * d/copyright-generator/strip-common-licenses.sh: Add GPLv3 to the
    list of common licenses.
  * d/JB-*.overrides.in, d/s/lintian-overrides: Update lintian overrides.
  * d/control: Add Java 24 Provides.
  * d/t/problemlist.csv: Update problemlist.csv for July release
  * d/t/jtreg-autopkgtest.{in,sh}: Increase jtreg test timeouts.

  [ Emmanuel Bourg ]
  * Restore and update the reproducible-properties-timestamp patch.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 10 Aug 2024 15:50:51 +0200

openjdk-24 (24~8ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 8.

  [ Vladimir Petko ]
  * d/t/write-problems.in: Fix typo that caused all tests present
    in d/t/problems.csv to be excluded.
  * d/t/{jdk,hotspot}-autopkgtest.in: Call d/t/write-problems.sh
    instead of d/t/write-problems.
  * d/t/*.sh: Regenerate tests.
  * d/rules: Enable fallback linker for architectures that do not
    provide a native one.
  * d/rules, d/control.in: Depend on pkgconf rather than pkg-config in
    bookworm and later releases. This resolves lintian warning
    build-depends-on-obsolete-package Build-Depends: pkg-config => pkgconf.
  * d/rules: Drop autotools-dev dependency for the modern debhelper.
    This resolves obsolete autotools-dev dependency lintian warning.
    See #844191.
  * d/t/control.in: allow stderr for smoke tests.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 30 Jul 2024 06:17:37 +0200

openjdk-24 (24~7ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 7.

  [ Vladimir Petko ]
  * d/rules: Enable jtreg again.
  * d/t/jni-link.{in,sh}: Drop obsolete test. After JDK-8331541 the build
    will fail if JVM contains undefined symbols.
  * d/rules: Add missing file.
  * d/p/jdk-8334502.patch: Fix iso8601_utctime armhf function.
  * d/p/jdk-8334895-proposed.patch: Resolve configure issue on arm64.
  * d/rules: Include /usr/share/dpkg/buildflags.mk to avoid configure failure
    due to undefined environment variables.
  * d/p/jdk-8335238-workaround.patch: Temporary revert fix for JDK-8320886
    on i386 to fix the ftbfs due to hanging jtreg tests.
  * d/rules, d/t/*: Collate all excluded tests into d/problemlist.csv.
  * d/rules: enable Fallback linker for Foreign Function and Memory API
    on i386 and armhf.
  * d/watch: Use fixed googletest version.
  * d/p/jdk-8336529-proposed.patch: Fix time_t migration issue on armhf,
    unable to set file last modified timestamp.

  [ Matthias Klose ]
  * Build using GCC 14.
  * Install jnativescan into jdk-headless.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 19 Jul 2024 09:01:13 +0200

openjdk-24 (24~4ea-1) experimental; urgency=medium

  * OpenJDK 24 snapshot, Build 4.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Jun 2024 19:36:22 +0200

openjdk-23 (23~28ea-1) unstable; urgency=medium

  * OpenJDK 23 snapshot, Build 28.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Jun 2024 17:35:55 +0200

openjdk-23 (23~20ea-1) unstable; urgency=medium

  * OpenJDK 23 snapshot, Build 20.

  [ Vladimir Petko ]
  * Add autopkgtest to test that JNI applications using the invocation API
    can be linked.
  * Add autopkgtest for libpcsclite initialisation.

  [ Matthias Klose ]
  * Build using GCC 10 for focal.
  * Fix fontmanager build with system harfbuzz.



=== debian/control ===
Source: openjdk-25
Section: java
Priority: optional
Maintainer: OpenJDK Team <openjdk-25@packages.debian.org>
Uploaders: Matthias Klose <doko@ubuntu.com>
Build-Depends: debhelper (>= 11),
  m4, lsb-release, zip, unzip,
  sharutils, gawk, cpio, procps, wdiff, pkgconf, fastjar (>= 2:0.96-0ubuntu2),
  time, strip-nondeterminism, debugedit (>= 4.16),
  jtreg7 (>= 7.4+1~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
  autoconf, automake, ant, ant-optional,
  g++-14 <!cross>,
  openjdk-24-jdk-headless:native | openjdk-25-jdk-headless:native,
  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig-dev, libfreetype-dev, libharfbuzz-dev,
  libffi-dev, libffi-dev:native,
  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, systemtap-sdt-dev [!powerpc !ppc64 !ppc64el !sh4 !s390x],
  libnss3-dev (>= 2:3.17.1),
  openjdk-25-jdk-headless <cross>,
Build-Depends-Indep: graphviz, pandoc,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://openjdk.java.net/
Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk
Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git

Package: openjdk-25-jdk-headless
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-jre-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Suggests: openjdk-25-demo, openjdk-25-source
Provides: java-sdk-headless (= ${vm:Version}), java-compiler
Description: OpenJDK Development Kit (JDK) (headless)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-25-jre-headless
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: ${jredefault:Depends}, ${cacert:Depends},
  ${jcommon:Depends}, ${dlopenhl:Depends},
  ${mountpoint:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenhl:Recommends},
  ${fontmanager:Recommends}, ${jsound:Recommends}
Suggests: libnss-mdns,
  fonts-dejavu-extra,
  fonts-ipafont-gothic, fonts-ipafont-mincho, fonts-wqy-microhei | fonts-wqy-zenhei, fonts-indic,
Provides: java-runtime-headless (= ${vm:Version}),
  ${defaultvm:Provides}, ${jvm:Provides}
Description: OpenJDK Java runtime, using ${vm:Name} (headless)
 Minimal Java runtime - needed for executing non GUI Java programs,
 using ${vm:Name}.

Package: openjdk-25-jdk
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-jre (= ${binary:Version}),
  openjdk-25-jdk-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libxt-dev
Suggests: openjdk-25-demo, openjdk-25-source, visualvm
Provides: java-sdk (= ${vm:Version}), java-compiler
Description: OpenJDK Development Kit (JDK)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-25-jre
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-jre-headless (= ${binary:Version}),
  ${dlopenjre:Depends}, ${fontmanager:Depends}, ${jsound:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenjre:Recommends}, ${bridge:Recommends}, fonts-dejavu-extra
Provides: java-runtime (= ${vm:Version})
Description: OpenJDK Java runtime, using ${vm:Name}
 Full Java runtime environment - needed for executing Java GUI and Webstart
 programs, using ${vm:Name}.

Package: openjdk-25-demo
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-jre (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Description: Java runtime based on OpenJDK (demos and examples)
 OpenJDK Java runtime

Package: openjdk-25-source
Architecture: all
Multi-Arch: foreign
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-jdk (>= ${source:Version}),
  ${misc:Depends}
Description: OpenJDK Development Kit (JDK) source files
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the Java programming language source files
 (src.zip) for all classes that make up the Java core API.

Package: openjdk-25-doc
Section: doc
Pre-Depends: ${dpkg:Depends}
Architecture: all
Multi-Arch: foreign
Priority: optional
Depends: ${misc:Depends},
  libjs-jquery,
  libjs-jquery-ui,
  libjs-jquery-ui-theme-base,
Suggests: openjdk-25-jdk
Description: OpenJDK Development Kit (JDK) documentation
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the API documentation.

Package: openjdk-25-dbg
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Priority: optional
Section: debug
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-jre-headless (= ${binary:Version}),
   ${misc:Depends},${shlibs:Depends}
Recommends: openjdk-25-jre (= ${binary:Version})
Suggests: openjdk-25-jdk (= ${binary:Version})
Conflicts: ${dbg:Conflicts}
Description: Java runtime based on OpenJDK (debugging symbols)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the debugging symbols.

Package: openjdk-25-testsupport
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Depends: openjdk-25-jdk (= ${binary:Version}),
  build-essential, xfwm4, xvfb, dbus-x11, libatk-wrapper-java,
  libatk-wrapper-java-jni, jtreg7 (>= 7.4+1~), libtestng7-java,
  ${shlibs:Depends},
  ${misc:Depends}
Description: Java runtime based on OpenJDK (regression test support)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains all the binary files needed to run the
 OpenJDK autopkg tests.

Package: openjdk-25-jre-zero
Architecture: amd64 arm64 ppc64 ppc64el riscv64 s390x
Multi-Arch: same
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-25-jre-headless (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: ${zerovm:Provides}
Description: Alternative JVM for OpenJDK, using Zero
 The package provides an alternative runtime using the Zero VM. Built on
 architectures in addition to the Hotspot VM as a debugging aid for those
 architectures which don't have a Hotspot VM.
 .
 The VM is started with the option `-zero'. See the README.Debian for details.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
include /usr/share/dpkg/buildflags.mk

unexport LANG LC_ALL

dh_version := $(shell dpkg-query -f '$${Version}\n' -W debhelper | sed -n 's/^\(.\).*/\1/p')

# using brace expansion and substring replacements (${var:0:2}).
SHELL = /bin/bash

# use gnu time in verbose mode if available, otherwise default to the shell builtin
ifneq (,$(wildcard /usr/bin/time))
  TIME = /usr/bin/time -v
else
  TIME = time
endif

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS		:= $(shell dpkg-architecture)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_HOST_ARCH_CPU	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_CPU)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

PATH := $(CURDIR)/bin:$(PATH)
export PATH

CHANGELOG_VARS := $(shell dpkg-parsechangelog | sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)
PKGYEAR := $(shell echo $(call vafilt,$(CHANGELOG_VARS),Timestamp) | date --utc +%Y)

distribution := $(shell lsb_release --id --short)
distrel := $(shell lsb_release --codename --short)
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
               elif dpkg-vendor --derives-from Debian; then echo Debian; \
               else echo Unknown; fi)
ifeq ($(distrel),n/a)
  distrel := sid
endif

ifneq (,$(filter $(distrel),precise))
  OBJCOPY := objcopy
  STRIP := strip
else
  OBJCOPY := $(DEB_HOST_GNU_TYPE)-objcopy
  STRIP := $(DEB_HOST_GNU_TYPE)-strip
endif

multiarch_dir = /$(DEB_HOST_MULTIARCH)

hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el riscv64 s390x
# see https://bugs.openjdk.org/browse/JDK-8321125 (armhf removed)
# see https://bugs.openjdk.org/browse/JDK-8338285,
# https://bugs.openjdk.org/browse/JDK-8341871 (i386 removed)
hotspot_archs	= amd64 arm64 ppc64 ppc64el riscv64 s390x
jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc ppc64 sh4 x32
jtreg_archs	+= armel loong64 mipsel mips64el
jtreg_archs	+= riscv64

# FIXME: use bootcycle builds for zero archs?
bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
#bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), amd64 i386),yes)
#bootcycle_build =
zbootcycle_build =
zbootcycle_build = yes
ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
  bootcycle_build =
  zbootcycle_build =
endif
ifneq (,$(filter nobootcycle, $(DEB_BUILD_OPTIONS)))
  bootcycle_build =
  zbootcycle_build =
endif

ifneq (,$(filter $(distrel),lucid precise quantal raring saucy trusty utopic vivid wily lenny etch squeeze wheezy jessie))
  is_default = no
else
  is_default = yes
endif

#is_upstream_release = yes

srcdir		= .
builddir	= build
zbuilddir	= build-zero

VENDOR		= openjdk
Vendor		= OpenJDK
TOP		= usr/lib/jvm
origin		= openjdk
basename	= openjdk-$(shortver)
ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
  priority	= $(if $(filter yes, $(is_default)),2511,2509)
  vm_name	= Hotspot JIT
else
  priority	= $(if $(filter yes, $(is_default)),2504,2503)
  vm_name	= Hotspot Zero
endif
jvmver		= 1.25.0
shortver	= 25
v_debian	:= $(shell echo $(PKGVERSION) | sed 's/ea//' | sed 's/\~us[[:digit:]]\+//')
v_upstream	:= $(shell echo $(v_debian) | sed 's/-[^-][^-]*$$//')
v_pkgrel	:= $(shell echo $(v_debian) | sed 's/^.*-//')

ifeq (yes,$(is_upstream_release))
  v_upbase      := $(word 1, $(subst +, , $(v_upstream)))
  v_upbuild     := $(word 2, $(subst +, , $(v_upstream)))
  ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
    $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
  endif
else
  v_upbase      := $(word 1, $(subst ~, , $(v_upstream)))
  v_upbuild     := $(word 2, $(subst ~, , $(v_upstream)))
  ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
    $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
  endif
endif

ifneq (,$(DEB_HOST_MULTIARCH))
  jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
  jdiralias	= java-$(jvmver)-$(origin)-$(DEB_HOST_ARCH)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)-common
  commonbasedir	= $(basedir)
  etcdir	= etc/java-$(shortver)-$(origin)
  testsuitedir	=	$(basedir)/testsuite
else
  jdirname	= java-$(shortver)-$(origin)
  jdiralias	= java-$(jvmver)-$(origin)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)
  etcdir	= etc/$(jdirname)
  testsuitedir	=	$(basedir)/testsuite
endif
security	= $(etcdir)/security
ifeq ($(bootcycle_build),yes)
  sdkimg	= bootcycle-build/images/jdk
  build_target	= bootcycle-images test-image
  testimg	= images/test
else
  sdkimg	= images/jdk
  build_target	= images test-image
  testimg	= images/test
endif
ifeq ($(zbootcycle_build),yes)
  zsdkimg	= bootcycle-build/images/jdk
  zbuild_target	= bootcycle-images test-image
else
  zsdkimg	= images/jdk
  zbuild_target	= images test-image
endif

# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
COMMA=,
SPACE = $(EMPTY) $(EMPTY)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

ifneq (,$(filter $(distrel), bookworm bullseye))
  jtreg_pkg = jtreg# debian will have jtreg7 in jtreg package
  testng_pkg = libtestng7-java
else
  jtreg_pkg = jtreg7
  testng_pkg = libtestng7-java
endif

with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(DEB_HOST_ARCH), alpha arc armel hppa ia64 loong64 mipsel mips64el powerpc riscv64 x32))
  with_check = disabled running check on $(DEB_HOST_ARCH)
endif
# no jtreg backport yet
ifneq (,$(filter $(distrel), precise trusty xenial bionic bookworm bullseye))
  with_check = disabled for $(distrel), no $(jtreg_pkg)
endif
#with_check = disabled, more recent jtreg needed

with_docs = $(if $(findstring nodoc, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(distrel), precise trusty))
  with_docs =
endif
#with_check = disabled for this upload

with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)

arch_map	:= alpha=alpha arc=arc arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 loong64=loong64 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32

jvmarch		:= $(strip $(patsubst $(DEB_HOST_ARCH_CPU)=%, %, \
			$(filter $(DEB_HOST_ARCH_CPU)=%, $(arch_map))))
ifeq ($(DEB_HOST_ARCH),x32)
  jvmarch := x32
endif

default_vm = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),hotspot,zero)

any_archs = alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32

altzero_archs = $(hotspot_archs)
ifneq (,$(filter $(distrel),trusty))
  altzero_archs := $(filter-out arm64, $(altzero_archs))
endif

ifneq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS)))
  altzero_archs =
else ifneq (,$(filter $(DEB_HOST_ARCH), $(altzero_archs)))
  alternate_vms += zero
  zero_dir = zero
endif

# needed for the jexec build
export DEBIAN_JDK_BASE_DIR := /$(basedir)

BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
			/usr/lib/jvm/java-25-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
			/usr/lib/jvm/java-24-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
		))))

ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
  BUILDJDK_HOME = $(CURDIR)/$(builddir)/$(sdkimg)
else
  BUILDJDK_HOME = $(BOOTJDK_HOME)
endif

ifneq (,$(filter $(distrel),saucy))
  export CC = gcc-4.8
  export CXX = g++-4.8
  bd_gcc = g++-4.8,
else ifneq (,$(filter $(distrel),utopic vivid jessie))
  export CC = gcc-4.9
  export CXX = g++-4.9

=== debian/tests/control ===
Test-Command: java --version
Depends: openjdk-25-jre-headless
Restrictions: allow-stderr, superficial

Test-Command: javac --version
Depends: openjdk-25-jdk-headless
Restrictions: allow-stderr, superficial

Tests: hotspot-autopkgtest.sh
Depends: @, jtreg7 (>= 7.4+1~), libtestng7-java, build-essential, bash, lsb-release, xfwm4, xvfb, xauth, dbus-x11, libatk-wrapper-java, libatk-wrapper-java-jni
Restrictions: allow-stderr, skippable, flaky, rw-build-tree

Tests: jdk-autopkgtest.sh
Depends: @, jtreg7 (>= 7.4+1~), libtestng7-java, build-essential, bash, lsb-release, xfwm4, xvfb, xauth, dbus-x11, libatk-wrapper-java, libatk-wrapper-java-jni
Restrictions: allow-stderr, skippable, flaky, rw-build-tree

Tests: dependencies.sh
Depends: @, build-essential, bash
Restrictions: allow-stderr, skippable, flaky

## openjdk-25 25~8ea

=== debian/changelog ===
openjdk-25 (25~8ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 8.
  * Disable explicit power8 optimization on ppc64el.
  * Build zero with --disable-precompiled-headers.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 02 Feb 2025 13:57:28 +0100

openjdk-25 (25~7ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 7.

  [ Vladimir Petko ]
  * d/p/jdk-8347014-proposed.patch: Define MAP_FIXED_NOREPLACE_value for alpha.
  * d/t/problems.csv: Add openjdk-24 and openjdk-25 to the problems.csv.
  * d/rules: Dump complete hs_err_pid and replay_pid logs to stdout.
  * d/t/problems.csv: Fix typo - remove jdk prefix for
    sun/security/util/Debug/DebugOptions.java.
  * d/rules: Disable dtrace on jammy armhf (was not enabled before and cannot
    be built due to a GCC ICE (see LP #2091225).

  [ Matthias Klose ]
  * Try to work-around a ftbfs on alpha. For now we keep the
    zero-alpha-workaround patch enabled instead of jdk-8347014-proposed.
  * d/rules: Also dump logs for zero builds and for build failures.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2025 21:12:03 +0100

## openjdk-25 25~10ea

=== debian/changelog ===
openjdk-25 (25~10ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 10.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Feb 2025 22:19:23 +0100

openjdk-25 (25~9ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 9.

  [ Pushkar Kulkarni ]
  * d/control: New graal-builder jdk package.
  * d/rules: Generate graal-builder jdk package.

  [ Matthias Klose ]
  * Fix jvmci package description.
  * Clean up jvmci package.
  * Install changelog and copyright for jvmci.
  * Remove some man pages, that appear with 24~36ea without binaries:
    jabswitch.1, jaccess*.1, kinit.1, klist.1, ktab.1.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 09 Feb 2025 20:32:32 +0100

=== debian/control ===
--- 
+++ 
@@ -153,6 +153,18 @@
  This package contains all the binary files needed to run the
  OpenJDK autopkg tests.
 
+Package: openjdk-25-jvmci-jdk
+Architecture: amd64
+Multi-Arch: same
+Priority: optional
+Pre-Depends: ${dpkg:Depends}
+Depends: ${jredefault:Depends}, ${cacert:Depends},
+  ${jcommon:Depends}, ${dlopenhl:Depends},
+  ${mountpoint:Depends},
+  ${shlibs:Depends}, ${misc:Depends}
+Description: JVMCI-enabled SDK for building graalvm
+  This package provides a JVMCI-enabled GraalVM builder Java SDK.
+
 Package: openjdk-25-jre-zero
 Architecture: amd64 arm64 ppc64 ppc64el riscv64 s390x
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -61,9 +61,12 @@
 # see https://bugs.openjdk.org/browse/JDK-8338285,
 # https://bugs.openjdk.org/browse/JDK-8341871 (i386 removed)
 hotspot_archs	= amd64 arm64 ppc64 ppc64el riscv64 s390x
+
 jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc ppc64 sh4 x32
 jtreg_archs	+= armel loong64 mipsel mips64el
 jtreg_archs	+= riscv64
+
+jvmci_archs	= amd64
 
 # FIXME: use bootcycle builds for zero archs?
 bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
@@ -91,6 +94,7 @@
 srcdir		= .
 builddir	= build
 zbuilddir	= build-zero
+jvmci_builddir	= build-jvmci
 
 VENDOR		= openjdk
 Vendor		= OpenJDK
@@ -128,6 +132,7 @@
   jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
   jdiralias	= java-$(jvmver)-$(origin)-$(DEB_HOST_ARCH)
   basedir	= $(TOP)/$(jdirname)
+  jvmci_basedir = $(basedir)-jvmci
   commonbasedir	= $(TOP)/java-$(shortver)-$(origin)-common
   commonbasedir	= $(basedir)
   etcdir	= etc/java-$(shortver)-$(origin)
@@ -136,6 +141,7 @@
   jdirname	= java-$(shortver)-$(origin)
   jdiralias	= java-$(jvmver)-$(origin)
   basedir	= $(TOP)/$(jdirname)
+  jvmci_basedir = $(basedir)-jvmci
   commonbasedir	= $(TOP)/java-$(shortver)-$(origin)
   etcdir	= etc/$(jdirname)
   testsuitedir	=	$(basedir)/testsuite
@@ -158,6 +164,8 @@
   zbuild_target	= images test-image
 endif
 
+jvmci_img	= images/graal-builder-jdk
+jvmci_target	= graal-builder-image
 # Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
 COMMA=,
 SPACE = $(EMPTY) $(EMPTY)
@@ -229,10 +237,3 @@
   BUILDJDK_HOME = $(BOOTJDK_HOME)
 endif
 
-ifneq (,$(filter $(distrel),saucy))
-  export CC = gcc-4.8
-  export CXX = g++-4.8
-  bd_gcc = g++-4.8,
-else ifneq (,$(filter $(distrel),utopic vivid jessie))
-  export CC = gcc-4.9
-  export CXX = g++-4.9

## openjdk-25 25~15ea

=== debian/changelog ===
openjdk-25 (25~15ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 15.
  * Fix some lintian warnings.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 23 Mar 2025 06:46:09 +0100

openjdk-25 (25~14ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 14.
  * debian/tests: Regenerate test files for 25.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 15 Mar 2025 08:13:37 +0100

## openjdk-25 25~16ea

=== debian/changelog ===
openjdk-25 (25~16ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 16.

  [ Vladimir Petko ]
  * d/p/jdk-8352800-proposed.patch: Add missing header.
  * d/p/test-empty-path.patch: Disable tests that require access to
    getFileStore(path) due to JDK-8166162.
  * d/t/jtreg-autopkgtest.*: Set ulimit -c unlimited for
    runtime/ErrorHandling/CreateCoredumpOnCrash.java.
  * d/t/problems.csv: Disable tests failing due to upstream bugs.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 27 Mar 2025 19:35:18 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
   m4, lsb-release, zip, unzip,
   sharutils, gawk, cpio, procps, wdiff, pkgconf, fastjar (>= 2:0.96-0ubuntu2),
   time, strip-nondeterminism, debugedit (>= 4.16),
-  jtreg7 (>= 7.4+1~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
+  jtreg7 (>= 7.5.1+1~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
   autoconf, automake, ant, ant-optional,
   g++-14 <!cross>,
   openjdk-24-jdk-headless:native | openjdk-25-jdk-headless:native,
@@ -143,7 +143,7 @@
 Multi-Arch: same
 Depends: openjdk-25-jdk (= ${binary:Version}),
   build-essential, xfwm4, xvfb, dbus-x11, libatk-wrapper-java,
-  libatk-wrapper-java-jni, jtreg7 (>= 7.4+1~), libtestng7-java,
+  libatk-wrapper-java-jni, jtreg7 (>= 7.5.1+1~), libtestng7-java,
   ${shlibs:Depends},
   ${misc:Depends}
 Description: Java runtime based on OpenJDK (regression test support)
@@ -163,7 +163,7 @@
   ${mountpoint:Depends},
   ${shlibs:Depends}, ${misc:Depends}
 Description: JVMCI-enabled SDK for building graalvm
-  This package provides a JVMCI-enabled GraalVM builder Java SDK.
+ This package provides a JVMCI-enabled GraalVM builder Java SDK.
 
 Package: openjdk-25-jre-zero
 Architecture: amd64 arm64 ppc64 ppc64el riscv64 s390x

## openjdk-25 25~17ea

=== debian/changelog ===
openjdk-25 (25~17ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 17.

  * Honour DEB_BUILD_OPTIONS=parallel=N while running jtreg tests (Helmut
    Grohne). Closes: #1095920.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 05 Apr 2025 08:42:24 +0200

## openjdk-25 25~20ea

=== debian/changelog ===
openjdk-25 (25~20ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 20.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 25 Apr 2025 05:43:35 +0200

## openjdk-25 25~22ea

=== debian/changelog ===
openjdk-25 (25~22ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 22.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 11 May 2025 12:03:44 +0200

## openjdk-25 25~25ea

=== debian/changelog ===
openjdk-25 (25~25ea-2) unstable; urgency=medium

  * Don't run the test suite on ppc64 and ppc64el for now, time outs
    on the Debian buildds.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Jun 2025 12:40:36 +0200

openjdk-25 (25~25ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 25.
  * Prefer OpenJDK 25 as a build dependency. Closes: #1106303.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 31 May 2025 11:40:07 +0200

=== debian/rules ===
--- 
+++ 
@@ -185,6 +185,12 @@
 ifneq (,$(filter $(DEB_HOST_ARCH), alpha arc armel hppa ia64 loong64 mipsel mips64el powerpc riscv64 x32))
   with_check = disabled running check on $(DEB_HOST_ARCH)
 endif
+# time outs on the builders
+ifneq (,$(filter $(distribution), Debian))
+  ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
+    with_check = disabled running check on $(DEB_HOST_ARCH)
+  endif
+endif
 # no jtreg backport yet
 ifneq (,$(filter $(distrel), precise trusty xenial bionic bookworm bullseye))
   with_check = disabled for $(distrel), no $(jtreg_pkg)
@@ -228,12 +234,3 @@
 
 BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
 			/usr/lib/jvm/java-25-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
-			/usr/lib/jvm/java-24-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
-		))))
-
-ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
-  BUILDJDK_HOME = $(CURDIR)/$(builddir)/$(sdkimg)
-else
-  BUILDJDK_HOME = $(BOOTJDK_HOME)
-endif
-

## openjdk-25 25~32ea

=== debian/changelog ===
openjdk-25 (25~32ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 32.

  [ Vladimir Petko ]
  * d/p/jdk-8359735-proposed.patch: Fix process tests failing in Ubuntu 25.10.
  * d/rules: Add -XX:TieredStopAtLevel=1 to boot jdk args for s390x to work
    around an Ubuntu LP builder issue.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Jul 2025 13:45:05 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
   jtreg7 (>= 7.5.1+1~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
   autoconf, automake, ant, ant-optional,
   g++-14 <!cross>,
-  openjdk-24-jdk-headless:native | openjdk-25-jdk-headless:native,
+  openjdk-25-jdk-headless:native | openjdk-24-jdk-headless:native,
   libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig-dev, libfreetype-dev, libharfbuzz-dev,
   libffi-dev, libffi-dev:native,
   zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, systemtap-sdt-dev [!powerpc !ppc64 !ppc64el !sh4 !s390x],

=== debian/rules ===
--- 
+++ 
@@ -185,12 +185,6 @@
 ifneq (,$(filter $(DEB_HOST_ARCH), alpha arc armel hppa ia64 loong64 mipsel mips64el powerpc riscv64 x32))
   with_check = disabled running check on $(DEB_HOST_ARCH)
 endif
-# time outs on the builders
-ifneq (,$(filter $(distribution), Debian))
-  ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
-    with_check = disabled running check on $(DEB_HOST_ARCH)
-  endif
-endif
 # no jtreg backport yet
 ifneq (,$(filter $(distrel), precise trusty xenial bionic bookworm bullseye))
   with_check = disabled for $(distrel), no $(jtreg_pkg)
@@ -234,3 +228,12 @@
 
 BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
 			/usr/lib/jvm/java-25-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
+			/usr/lib/jvm/java-24-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
+		))))
+
+ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
+  BUILDJDK_HOME = $(CURDIR)/$(builddir)/$(sdkimg)
+else
+  BUILDJDK_HOME = $(BOOTJDK_HOME)
+endif
+

=== debian/watch ===
version=4
opts=\
repack,repacksuffix=ea,oversionmangle=s/\+(\d+)/\~$1/,dversionmangle=s/\~(\d*)ea$/\+$1/,\
compression=xz, \
    https://github.com/openjdk/jdk/tags \
    (?:.*?/)?jdk-(25[\+\.\d]*)\.tar\.gz

opts=\
component=googletest,\
repack,\
compression=xz \
    https://github.com/google/googletest/tags \
    (?:.*?/)?v(1.14.0)\.tar\.gz 1.14.0

## openjdk-25 25~34ea

=== debian/changelog ===
openjdk-25 (25~34ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 34.

  [ Matthias Klose ]
  * Update VCS attributes.

  [ Vladimir Petko ]
  * d/copyright-generator/copyright-gen.py: bump copyright year.
  * d/copyright: regenerate.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 05 Aug 2025 08:35:23 +0200

## openjdk-25 25~36ea~us1

=== debian/changelog ===
openjdk-25 (25~36ea~us1-0ubuntu1) questing; urgency=medium

  * OpenJDK 25 snapshot, Build 36.

 -- Vladimir Petko <vladimir.petko@canonical.com>  Fri, 15 Aug 2025 08:19:23 +1200

## openjdk-25 25~36ea

=== debian/changelog ===
openjdk-25 (25~36ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 36.
  * Build using GCC 15 on development releases.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 29 Aug 2025 11:59:40 +0200
